#!/bin/sh
#
# Copyright 2015-2021 Univention GmbH
#
# https://www.univention.de/
#
# All rights reserved.
#
# The source code of this program is made available
# under the terms of the GNU Affero General Public License version 3
# (GNU AGPL V3) as published by the Free Software Foundation.
#
# Binary versions of this program provided by Univention to you as
# well as other copyrighted, protected or trademarked materials like
# Logos, graphics, fonts, specific documentations and configurations,
# cryptographic keys etc. are subject to a license agreement between
# you and Univention and not subject to the GNU AGPL V3.
#
# In the case you use this program under the terms of the GNU AGPL V3,
# the program is provided in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License with the Debian GNU/Linux or Univention distribution in file
# /usr/share/common-licenses/AGPL-3; if not, see
# <https://www.gnu.org/licenses/>.
set -e
umask 022

paramfile="$(ucr get ldap/tls/dh/paramfile)"
[ -n "$paramfile" ] || exit 0

log="$(mktemp)"
exec 3>&1 >"$log" 2>&1

tmp=$(mktemp "$paramfile.XXXXXXXXXX")
cleanup () {
	rv="$?"
	set +e
	cat "$log" >&3
	rm -f "$tmp" "$log"
	return "$rv"
}
trap cleanup EXIT

openssl dhparam -out "$tmp" -2 2048
chmod 644 "$tmp"
mv "$tmp" "$paramfile"

# shellcheck source=/dev/null
. /usr/share/univention-lib/ucr.sh
if is_ucr_true ldap/tls/dh/restart
then
	invoke-rc.d slapd crestart || :
fi

: >"$log"
exit 0
